#!/usr/bin/python

from distutils.core import setup, Extension

import sys

if sys.platform[:5] == 'linux':
	MACROS	= {'define' : []}
	LIBS	= []
else:
	MACROS	= {
		'define'	: [('MSWINDOWS', None)],
		  }
	LIBS	= ['ws2_32']

SRC	= ['src/rpcBase64.c', 'src/rpcBoolean.c',  'src/rpcClient.c',
	   'src/rpcDate.c',   'src/rpcDispatch.c', 'src/rpcInternal.c',
	   'src/rpcServer.c', 'src/rpcSource.c',   'src/rpcUtils.c',
	   'src/xmlrpc.c',    'src/xmlrpcmodule.c']

setup(	name		= 'xmlrpc',
	version		= '1.0',
	description	= 'xmlrpc for Python',
	author		= 'Shilad Sen',
	author_email	= 'shilad.sen@sourcelight.com',
	license		= 'GNU Lesser General Public License',
	url = "http://",
	py_modules	= ['xmlrpc'],
	ext_modules	= [Extension(
				'_xmlrpc',
				SRC,
				define_macros=MACROS['define'],
				libraries=LIBS,
				)],
	)
