/*
 * Copyright (C) 2001, Shilad Sen, Sourcelight Technologies, Inc.
 * See xmlrpc.h or the README for more copyright information.
 *
 * An xmlrpc client which can make rpc calls to a remote xmlrpc server
 */

#ifndef _RPCCLIENT_H_
#define _RPCCLIENT_H_


#include "rpcInclude.h"
#include "rpcSource.h"
#include "rpcDispatch.h"
#include "rpcServer.h"


PyTypeObject	rpcClientType;



/*
 * A new xmlrpc client
 */
typedef struct {
	PyObject_HEAD			/* python standard */
	rpcDisp		*disp;
	rpcSource	*src;
} rpcClient;


rpcClient	*rpcClientNew(void);
rpcClient	*rpcClientNewFromServer(rpcServer *servp);
void		rpcClientDealloc(rpcClient *cp);
bool		rpcClientNbConnect(
			rpcClient	*cp,
			char		*host,
			int		port,
			bool		(*func) (
				rpcDisp *,
				rpcSource *,
				int,
				PyObject *
			),
			PyObject	*params
		);
bool		rpcClientConnect(
			rpcClient	*cp,
			char		*host,
			int		port,
			double		timeout
		);
bool		rpcClientNbExecute(
			rpcClient	*cp,
			char		*method,
			PyObject	*args, 
			bool		(*func) (
				rpcDisp *,
				rpcSource *,
				int,
				PyObject *
			),
			PyObject	*params,
			PyObject	*addInfo
		);
PyObject	*rpcClientExecute(
			rpcClient	*cp,
			char		*method,
			PyObject	*params,
			PyObject	*addInfo,
			double		timeout
		);


#endif /* _RPCCLIENT_H_ */
